function Create(self)
	function ResetTarget(self)
		self.timing = SelectRand(180, 220)
		self.ray = true
		self.fire = false
		self.valid = 3
		self.trgAng = nil
		self.TrgVel = nil
		
		table.remove(self.Targets, self.ti)
		
		if #self.Targets > 0 then
			self.ti = SelectRand(1, #self.Targets + 1)
		else
			self.ti = nil
		end
	end
	
	self.GunTimer = Timer()
	self.ReloadTimer = Timer()
	self.UpdateTimer = Timer()
	self.gunAng = 1.571
	self.maxAmmo = 40
	self.ammo = self.maxAmmo
	self.reloadTime = 2500
	self.rof = 75
	self.rotSpeed = 0
	self.Targets = {}
	
	-- Multiply by n to reduce precision
	self.multi = 4*(2000 * TimerMan.DeltaTimeSecs)	-- bullet vel(pix/s) * dt
	self.factor = 4*(FrameMan.PPM * TimerMan.DeltaTimeSecs)
	
	-- Init commuication
	if not UAV then
		UAV = {}
	end
	
	if not UAV.Turrets then
		UAV.Turrets = {}
		UAV.TrtCtrl = {}
		UAV.noTurrets = 0
		UAV.Token = 0
		UAV.maxTurret = 0
	end
	
	self.index = #UAV.Turrets + 1
	if self.index > UAV.maxTurret then
		UAV.maxTurret = self.index
	end
	
	UAV.Turrets[self.index] = true
	UAV.noTurrets = UAV.noTurrets + 1
	
	ResetTarget(self)
end

function Destroy(self)
	if MovableMan:ValidMO(self.Barrel) and self.Barrel.PresetName == "50 cal Barrel" then
		self.Barrel:GibThis()
	end
	
	UAV.Turrets[self.index] = nil
	UAV.noTurrets = UAV.noTurrets - 1
	if self.index == UAV.maxTurret then
		UAV.maxTurret = UAV.maxTurret - 1
	end
end

function Update(self)
	self:GetController():SetState(Controller.MOVE_RIGHT, false)
	self:GetController():SetState(Controller.MOVE_LEFT, false)
	
	if UAV.TrtCtrl[self.Team] then
		if #self.Targets > 0 then	-- Track existing target
			if self.UpdateTimer:IsPastSimMS(self.timing) then
				if MovableMan:ValidMO(self.Targets[self.ti]) and self.Targets[self.ti] ~= "Entity" and not self.Targets[self.ti]:IsDead() then
					self.UpdateTimer:Reset()
					if not self.TrgVel then
						self.trgAng = SceneMan:ShortestDistance(self.Pos, self.Targets[self.ti].Pos, false).AbsRadAngle
						self.TrgVel = Vector(self.Targets[self.ti].Vel.X, self.Targets[self.ti].Vel.Y)	-- Target's previous velocity
						self.timing = 80
					else
						local PredPos = Vector(self.Targets[self.ti].Pos.X, self.Targets[self.ti].Pos.Y)
						local Dist = SceneMan:ShortestDistance(self.Pos, PredPos, false)
						local Updt2Hit = math.floor(Dist.Magnitude/self.multi+0.5)
						local Acc = (self.Targets[self.ti].Vel - self.TrgVel)/5	-- Estimate acceleration
						local Vel = Vector(self.Targets[self.ti].Vel.X, self.Targets[self.ti].Vel.Y)
						
						for i = 1, Updt2Hit do
							Vel = Vel + Acc
							PredPos = PredPos + Vel * self.factor
						end
						
						--[[ Debug
						local Dot = CreateMOSParticle("Eye Small", "Debug.rte")
						Dot.Pos = PredPos
						MovableMan:AddParticle(Dot)
						-- End debug]]
						
						self.TrgVel = Vector(self.Targets[self.ti].Vel.X, self.Targets[self.ti].Vel.Y)	-- Target's previous velocity
						Dist = SceneMan:ShortestDistance(self.Pos, PredPos, false)
						if Dist.Magnitude < 800 and self.Pos.Y > self.Targets[self.ti].Pos.Y then
							self.trgAng = Dist.AbsRadAngle
							self.fire = true
						elseif self.fire or self.valid < 1 then	-- Target moved out of range
							ResetTarget(self)
						else
							self.valid = self.valid - 1
						end
					end
				else
					ResetTarget(self)
				end
			end
		elseif UAV.Token == self.index and self.search then	-- Search for target
			self.search = false
			local Dist = nil
			for Act in MovableMan.Actors do
				if Act.Team ~= self.Team and self.Pos.Y > Act.Pos.Y and not(Act:IsDead() or Act:IsStatus(Actor.DYING)) and Act.ClassName ~= "Entity" then
					Dist = SceneMan:ShortestDistance(self.Pos, Act.Pos, false)
					if Dist.Magnitude < 1000 then
						table.insert(self.Targets, Act)
						if #self.Targets > 2 then
							break
						end
					end
				end
			end
			
			local Dot = CreateMOPixel("Small Blue Glow", "Air Support.rte")
			Dot.Pos = self.Pos + self:RotateOffset(Vector(9,-9))
			Dot.Age = 1
			MovableMan:AddParticle(Dot)
			
			if #self.Targets > 0 then
				self.ti = SelectRand(1, #self.Targets + 1)	-- Pick a target at random
			else
				self.trgAng = nil
			end
		elseif UAV.Token ~= self.index then
			self.search = true
		end
		
		if self.ammo < 1 and self.ReloadTimer:IsPastSimMS(self.reloadTime) then
			self.ammo = self.maxAmmo
		end
	end
	
	local rotDiff = 0
	if self.trgAng then	-- Move barrel towards aimpoint
		rotDiff = self.trgAng - self.gunAng
		self.rotSpeed = 0.08
		if self.fire and self.GunTimer:IsPastSimMS(self.rof) and self.ammo > 0 and math.abs(rotDiff) < 0.1 then	-- Fire
			self.GunTimer:Reset()
			
			if self.ray then
				local id = SceneMan:CastMORay(self.Pos, self.Barrel:RotateOffset(Vector(400, 0)), self.ID, 128, false, 5)	-- Ignore grass
				local Targ = MovableMan:GetMOFromID(MovableMan:GetRootMOID(id))
				if Targ and Targ.Team == self.Team then
					ResetTarget(self)
				end
			end
			
			if self.fire then
				self.ray = not self.ray
				
				local bulletType = "AA 50 cal"
				if self.ammo % 4 == 0 then
					bulletType = "AA 50 cal Tracer"
				end
				
				local Emitter = CreateAEmitter(bulletType, "Air Support.rte")
				if self.ammo % 2 == 0 then
					Emitter.Pos = self.Barrel.Pos + self.Barrel:RotateOffset(Vector(17,-2))
				else
					Emitter.Pos = self.Barrel.Pos + self.Barrel:RotateOffset(Vector(17,3))
				end
				
				Emitter.RotAngle = self.gunAng
				MovableMan:AddParticle(Emitter)
				
				self.ammo = self.ammo - 1
				if self.ammo == 0 then
					self.ReloadTimer:Reset()
				end
			end
		end
	else	 	-- No target; move barrel towards pi/2
		rotDiff = 1.571 - self.gunAng
		self.rotSpeed = 0.005
	end
	
	if math.abs(rotDiff) > 0.01 then
		if rotDiff > 0 then
			self.gunAng = math.min(self.gunAng + math.min(self.rotSpeed, rotDiff), self.RotAngle + 2.94)
		else
			self.gunAng = math.max(self.gunAng + math.max(-self.rotSpeed, rotDiff), self.RotAngle + 0.20)
		end
	end
	
	-- Update barrel
	if not (MovableMan:ValidMO(self.Barrel) and self.Barrel.PresetName == "50 cal Barrel") then
		self.Barrel = CreateMOSRotating("50 cal Barrel")
		MovableMan:AddParticle(self.Barrel)
	end
	
	self.Barrel.Pos = self.Pos + self:RotateOffset(Vector(0, -6))
	self.Barrel.RotAngle = self.gunAng
	self.Barrel.Age = 1
end