function Create(self)
	function ResetTarget(self)
		self.damage = false
		self.priority = false
		
		if self.ti then
			local Key = self.Targets[self.ti]
			self.Targets[self.ti] = nil
			if Key and self.TargetKeys then
				self.TargetKeys[Key] = nil
			end
		end
		
		if #self.Targets > 0 then
			self.ti = SelectRand(1, #self.Targets + 1)
			
			if self.TargetTimer then
				self.TargetTimer:Reset()
			end
		else
			self.ti = nil
		end
	end
	
	self.TargetTimer = Timer()
	self.TargetKeys = {}
	self.Targets = {}
	
	self.Barrel = CreateMOSRotating("Laser Barrel", "Air Support.rte")
	self.Barrel.RotAngle = self.RotAngle
	self.Barrel.Pos = self.Pos + self:RotateOffset(Vector(0, -19))
	MovableMan:AddParticle(self.Barrel)

	if not UAV.Ordnance then
		UAV.Ordnance = {}
	end
	
	-- Init commuication
	if not UAV then
		UAV = {}
	end
	
	if not UAV.Turrets then
		UAV.Turrets = {}
		UAV.TrtCtrl = {}
		UAV.noTurrets = 0
		UAV.Token = 0
		UAV.maxTurret = 0
	end
	
	self.index = #UAV.Turrets + 1
	if self.index > UAV.maxTurret then
		UAV.maxTurret = self.index
	end
	
	UAV.Turrets[self.index] = true
	UAV.noTurrets = UAV.noTurrets + 1
	
	ResetTarget(self)
end

function Destroy(self)
	if MovableMan:ValidMO(self.Barrel) and self.Barrel.PresetName == "Laser Barrel" then
		self.Barrel:GibThis()
	end
	
	UAV.Turrets[self.index] = nil
	UAV.noTurrets = UAV.noTurrets - 1
	if self.index == UAV.maxTurret then
		UAV.maxTurret = UAV.maxTurret - 1
	end
end

function Update(self)
	self:GetController():SetState(Controller.MOVE_RIGHT, false)
	self:GetController():SetState(Controller.MOVE_LEFT, false)
	
	if self.Barrel and self.Age > 100 then
		-- Update barrel
		if MovableMan:ValidMO(self.Barrel) and self.Barrel.PresetName == "Laser Barrel" then
			self.Barrel.Vel = Vector(0,0)
			self.Barrel.Pos = self.Pos + self:RotateOffset(Vector(0, -19))
			self.Barrel.RotAngle = self.RotAngle
			self.Barrel.Age = 1
		else
			self.Barrel = nil
			return
		end
		
		if UAV.TrtCtrl[self.Team] then
			if not self.priority and #UAV.Ordnance > 0 then
				self.priority = true
				self.Targets = {}
				local Dist = nil
				for i,Trg in next, UAV.Ordnance do
					if MovableMan:ValidMO(Trg) and self.Pos.Y > Trg.Pos.Y then
						Dist = SceneMan:ShortestDistance(self.Pos, Trg.Pos, false)
						if Dist.Magnitude < 900 then
							local index = #self.Targets + 1
							self.TargetKeys[Trg] = true
							self.Targets[index] = Trg
							if index > 3 then
								break
							end
						end
					end
				end
				
				if #self.Targets > 0 then
					self.ti = SelectRand(1, #self.Targets + 1)	-- Pick a target at random
					self.TargetTimer:Reset()
				end
			elseif UAV.Token == self.index and self.search then	-- Search for target
				self.search = false
				self.priority = false
				local Dist = nil
				for Act in MovableMan.Actors do
					if not self.TargetKeys[Act] and Act.Team ~= self.Team and self.Pos.Y > Act.Pos.Y and not(Act:IsDead() or Act:IsStatus(Actor.DYING)) and Act.ClassName ~= "Entity" then
						Dist = SceneMan:ShortestDistance(self.Barrel.Pos, Act.Pos, false)
						if Dist.Magnitude < 900 then
							local index = #self.Targets + 1
							self.TargetKeys[Act] = true
							self.Targets[index] = Act
							if index > 3 then
								break
							end
						end
					end
				end
				
				local Dot = CreateMOPixel("Small Blue Glow", "Air Support.rte")
				Dot.Pos = self.Pos + self:RotateOffset(Vector(9,-9))
				Dot.Age = 1
				MovableMan:AddParticle(Dot)
				
				if #self.Targets > 0 then
					self.ti = SelectRand(1, #self.Targets + 1)	-- Pick a target at random
					self.TargetTimer:Reset()
				end
			elseif UAV.Token ~= self.index then
				self.search = true
			end
			
			if self.ti then
				if self.Targets[self.ti] and MovableMan:ValidMO(self.Targets[self.ti]) then
					local Distance = SceneMan:ShortestDistance(self.Barrel.Pos, self.Targets[self.ti].Pos, false)
					local Org = UAV.Offset(self.Barrel.Pos, Distance.AbsRadAngle, 10)
					local FreePos = Vector()
					local HitPos = Vector()
					local dist = SceneMan:CastObstacleRay(Org, Distance, HitPos, FreePos, -1, -1, 2)	-- really check every third pixel?
					
					if dist > 0 then
						local ang = SceneMan:ShortestDistance(HitPos, self.Targets[self.ti].Pos, false).AbsRadAngle
						local Inside = UAV.Offset(HitPos, ang, 3)
						local MO = MovableMan:GetMOFromID(SceneMan:GetMOIDPixel(Inside.X, Inside.Y))
						if MO and (not MO:IsActor() or MO.Team ~= self.Team) then
							if self.TargetTimer:IsPastSimMS(30) then
								local Laser = CreateMOPixel("Laser Glow", "Air Support.rte")
								Laser.Pos = FreePos
								Laser.Age = 1
								MovableMan:AddParticle(Laser)
								
								Laser = CreateMOPixel("Laser Glow", "Air Support.rte")
								Laser.Pos = HitPos
								Laser.Age = 1
								MovableMan:AddParticle(Laser)
								
								if self.damage then
									self.damage = false
									
									if MO.ClassName == "ADoor" or MO.ClassName == "MOSRotating" then	-- Increase damage to missiles
										Laser = CreateMOPixel("AA Laser", "Air Support.rte")
										Laser.Vel = MO.Vel + Vector(84,0):RadRotate((FreePos - MO.Pos).AbsRadAngle)
										Laser.Pos = FreePos
										MovableMan:AddParticle(Laser)
									elseif PosRand() < 0.4 then
										Laser = CreateMOPixel("AA Laser", "Air Support.rte")
										Laser.Vel = MO.Vel + Vector(42,0):RadRotate((FreePos - MO.Pos).AbsRadAngle)
										Laser.Pos = FreePos
										MovableMan:AddParticle(Laser)
									end
								else
									self.damage = true
								end
								
								if PosRand() < 0.35 then
									Laser = CreateMOSParticle("Tiny Smoke Ball Fast", "Air Support.rte")
									Laser.Pos = HitPos
									Laser.Vel = MO.Vel * RangeRand(0.9,1.1)
									MovableMan:AddParticle(Laser)
								end
							end
						else
							ResetTarget(self)
						end
					else
						ResetTarget(self)
					end
				else
					ResetTarget(self)
				end
			end
		end
	end
end
