function Create(self)
	-- Remove any inventory
	if not self:IsInventoryEmpty() then
		self.HitsMOs = false
		self.GetsHitByMOs = false
		self.ToDelete = true
		
		local Activ = ActivityMan:GetActivity()
		Activ:ReportDeath(self.Team, -1)
		Activ:SetTeamFunds(Activ:GetTeamFunds(self.Team) + self.TotalValue - self.GoldValue, self.Team)
		
		-- Create an empty drop crate
		local Act = CreateACRocket("SAM Site Drop", "Air Support.rte")
		if Act then
			Act.Pos = self.Pos
			Act.Vel = self.Vel
			Act.RotAngle = self.RotAngle
			Act.Team = self.Team
			MovableMan:AddActor(Act)
		end
	else
		self.Vel = Vector(0, math.max(self.Vel.Y, 15))
		self.spawn = true
		self.lastVel = self.Vel.Magnitude
		self.lastRotAngle = 0
		self.max = 0
	end
end

function Destroy(self)
	if self.spawn then
		if MovableMan:ValidMO(self.leftThruster) then
			self.leftThruster:GibThis()
		end
		
		if MovableMan:ValidMO(self.rightThruster) then
			self.rightThruster:GibThis()
		end
		
		if self.max > 10 then
			-- spawn gibs
		else
			local Act = CreateActor("SAM Site", "Air Support.rte")
			if Act then
				Act.Pos = self.Pos + Vector(0,-3)
				Act.Vel = self.Vel
				Act.RotAngle = self.lastRotAngle
				Act.Team = self.Team
				MovableMan:AddActor(Act)
			end
			
			if self.max > 7 then
				Act.Health = Act.Health - (PosRand()*self.max*4+1)
			end
		end
	end
end

function Update(self)
	if self.spawn then
		local ret
		if self.Vel.Magnitude < 1 then
			self.open = (self.open or 0) + 1
			if self.open > 20 then
				self:GibThis()
			end
		elseif self.Vel.Y > 5 and SceneMan:FindAltitude(self.Pos, 400, 4) < self.Vel.Y*9 then
			self.Vel = self.Vel - self:RotateOffset(Vector(0, self.Vel.Y*0.05))
			ret = true
		end
	
		if not MovableMan:ValidMO(self.leftThruster) then
			self.leftThruster = CreateAEmitter("Left Drop Thruster", "Air Support.rte")
			MovableMan:AddParticle(self.leftThruster)
		end
	
		self.leftThruster.Age = 1
		self.leftThruster.RotAngle = self.RotAngle
		self.leftThruster.Pos = self.Pos + self:RotateOffset(Vector(-22,3))
	
		if not MovableMan:ValidMO(self.rightThruster) then
			self.rightThruster = CreateAEmitter("Right Drop Thruster", "Air Support.rte")
			MovableMan:AddParticle(self.rightThruster)
		end
		
		self.rightThruster.Age = 1
		self.rightThruster.RotAngle = self.RotAngle
		self.rightThruster.Pos = self.Pos + self:RotateOffset(Vector(22,3))
		
		if ret then
			self.hot = true
			local Smoke
			if PosRand() < 0.33 then
				Smoke = CreateMOSParticle("Fire Puff Small", "Base.rte")
			else
				Smoke = CreateMOSParticle("Side Thruster Blast Ball 1", "Base.rte")
			end
			
			if Smoke then
				self.left = not self.left
				if self.left then
					Smoke.Pos = self.Pos + self:RotateOffset(Vector(-24,5))
					Smoke.Vel = UAV.Offset(self.Vel, self.RotAngle+RangeRand(3.8,4.0), RangeRand(12,20))
				else
					Smoke.Pos = self.Pos + self:RotateOffset(Vector(24,5))
					Smoke.Vel = UAV.Offset(self.Vel, self.RotAngle-RangeRand(0.7,0.9), RangeRand(12,20))
				end
				
				Smoke:SetWhichMOToNotHit(self, -1)
				MovableMan:AddParticle(Smoke)
				
				self.leftThruster:EnableEmission(true)
				self.rightThruster:EnableEmission(true)
			end
		elseif self.hot then
			local Smoke = CreateMOSParticle("Tiny Smoke Ball 1", "Base.rte")
			if Smoke then
				self.left = not self.left
				if self.left then
					Smoke.Pos = self.Pos + self:RotateOffset(Vector(-24,5))
					Smoke.Vel = UAV.Offset(self.Vel, self.RotAngle+RangeRand(3.8,4.0), RangeRand(2,4))
				else
					Smoke.Pos = self.Pos + self:RotateOffset(Vector(24,5))
					Smoke.Vel = UAV.Offset(self.Vel, self.RotAngle-RangeRand(0.7,0.9), RangeRand(2,4))
				end
				
				Smoke:SetWhichMOToNotHit(self, -1)
				MovableMan:AddParticle(Smoke)
				
				self.leftThruster:EnableEmission(false)
				self.rightThruster:EnableEmission(false)
			end
		end
		
		local tmp = self.lastVel - self.Vel.Magnitude
		if tmp > self.max then
			self.max = tmp
		end
		
		self.lastVel = self.Vel.Magnitude
		self.lastRotAngle = self.RotAngle
	end
end