local tmp = package.path
package.path = package.path .. ";Air Support.rte/?.lua"
require("common")
package.path = tmp

function Create(self)
	UAV.Initialize(self)
	self.payload = 55	-- fuel
	
	-- specific for this craft
	self.TailPos:SetXY(-30, 0)
	self.occlusion = 80
	self.maxThrot = 3700
	self.minThrot = 2800
	self.throttle = self.minThrot
	self.ammo = 0
	self.liftMultiplier = 5
	self.liftMaximum = 6200
	self.stallSpeed = 8
	self.booster = false
end

function Destroy(self)
	UAV.Destroy(self)
	
	if MovableMan:ValidMO(self.Boost) then
		self.Boost.ToDelete = true
	end
end

function Update(self)
	UAV.Move(self)
	
	if self:IsPlayerControlled() then
		if self:GetController():IsState(Controller.PRIMARY_ACTION) then
			self:GibThis()
			return
		end
		
		UAV.PlayerControlled(self)
		UAV.Map(self)
		
		if self.payload > 0 and self.Ctrl:IsState(self.secondary) then
			self.throttle = 10000
			self.maxThrot = 10000
			self.minThrot = 10000
			self.occlusion = 120
			self.booster = true
			
			if not self.Boost then
				self.Boost = CreateAEmitter("Cruise Missile Booster Sound", "Air Support.rte")
				if self.Boost then
					self.Boost.Pos = self.Pos
					MovableMan:AddParticle(self.Boost)
				end
			end
		end
	elseif self.playerCtrl then
		UAV.Destroy(self)
	end
	
	-- booster
	if self.booster then
		if self.payload > 0 then
			if self.DropTimer:IsPastSimMS(33) then
				self.DropTimer:Reset()
				
				local Blast = CreateAEmitter("Back Blast", "Air Support.rte")
				Blast.Pos = UAV.Offset(self.Pos, self.angle + 3.1416, 25) -- backwards n units
				Blast.Vel = self.Vel
				Blast.RotAngle = self.angle
				MovableMan:AddParticle(Blast)
				
				self.occlusion = self.occlusion + 1
				self.payload = self.payload - 1
			end
			
			if MovableMan:ValidMO(self.Boost) then
				self.Boost.Pos = self.Pos
			end
		else
			self.throttle = 5000
			self.maxThrot = 5000
			self.minThrot = 500
			self.occlusion = 80
			self.booster = false
			
			if MovableMan:ValidMO(self.Boost) then
				self.Boost.ToDelete = true
			end
		end
	end
end