function Create(self)
	self.Ctrl = self:GetController()
	self.burstLeft = 0
	self.burstRight = 0
	self.LZposX = Vector(self.Pos.X, 0)
	
	-- The controller class
	PIDController = {}
	PIDController.mt = {__index = PIDController}
	function PIDController:New(p_in, i_in, d_in, Int_in, Last_in)
		return setmetatable(
			{
				p = p_in,
				i = i_in,
				d = d_in,
				Integral = Int_in,
				Last = Last_in
			},
			PIDController.mt)
	end
	
	function PIDController:UpdateScal(input, target)
		local Delta = input - target
		local Dist = input - self.Last
		self.Last = input
		self.Integral = self.Integral + Delta
		return self.p*Delta + self.i*self.Integral + self.d*Dist
	end
	
	-- The controller
	self.AngPID = PIDController:New(1.5, 0.01, 0.005, 0, self.RotAngle)
	self.XposPID = PIDController:New(5, 0.0001, 0.5, 0, self.LZposX.X)
end

function Update(self)
	if not self:IsPlayerControlled() then
		local Dist = SceneMan:ShortestDistance(Vector(self.Pos.X,0), self.LZposX, false)
		if Dist.Magnitude > 300 then
			self.LZposX.X = self.LZposX.X * 0.8 + self.Pos.X * 0.2
		end
		
		local Speed = self.Vel*20
		local range = SceneMan:CastObstacleRay(self.Pos, Speed, Vector(), Vector(), self.ID, 0, 6)
		if range >= 0 then
			self.LZposX.X = self.LZposX.X * 0.6 + (self.Pos+Speed).X * 0.4
		end
		
		local targetAng = 0
		local x = self.XposPID:UpdateScal(self.Pos.X+self.Vel.X*30, self.LZposX.X)
		if x < -7 then
			self.Ctrl:SetState(Controller.MOVE_LEFT, false)
			self.Ctrl:SetState(Controller.MOVE_RIGHT, true)
			targetAng = math.max(-0.1 + x/3000, -0.7)
		elseif x > 7 then
			self.Ctrl:SetState(Controller.MOVE_LEFT, true)
			self.Ctrl:SetState(Controller.MOVE_RIGHT, false)
			targetAng = math.min(0.1 + x/3000, 0.7)
		end
		
		x = self.AngPID:UpdateScal(self.RotAngle+self.AngularVel, targetAng)
		if x < -1.2 then	-- Turn on and off to trigger a burst
			if self.burstLeft < 1 then
				self.burstLeft = 2	-- Wait n frames until next burst (lower -> better control)
				self.Ctrl:SetState(Controller.MOVE_LEFT, true)
			else
				self.burstLeft = self.burstLeft - 1
				self.Ctrl:SetState(Controller.MOVE_LEFT, false)
			end
		elseif x < -0.5 then
			self.Ctrl:SetState(Controller.MOVE_LEFT, true)
		elseif x > 1.2 then
			if self.burstRight < 1 then
				self.burstRight = 2
				self.Ctrl:SetState(Controller.MOVE_RIGHT, true)
			else
				self.burstRight = self.burstRight - 1
				self.Ctrl:SetState(Controller.MOVE_RIGHT, false)
			end
		elseif x > 0.5 then
			self.Ctrl:SetState(Controller.MOVE_RIGHT, true)
		end
	end
end
