function Create(self)	
	self.SearchTimer = Timer()
	self.searchTeam = -1
	self.timing = RangeRand(100, 200)
	self.aimAngle = self.RotAngle
	self.round = 1
	self.next = (PosRand() < 0.5)
end

function Destroy(self)	
	if MovableMan:ValidMO(self.Barrel) then
		self.Barrel:GibThis()
	end
end

function Update(self)
	-- Validate barrel
	if not MovableMan:ValidMO(self.Barrel) or self.Barrel.PresetName ~= "SAM Launcher" then
		self.Barrel = CreateMOSRotating("SAM Launcher", "Air Support.rte")
		MovableMan:AddParticle(self.Barrel)
	end
	
	self.Barrel.Age = 1
	self.Barrel.ToSettle = false
	self.Barrel.Pos = self.Pos + self:RotateOffset(Vector(0,-18))
	self.Barrel.RotAngle = self.aimAngle
	
	if self.targetAngle then
		if self.targetAngle > self.aimAngle then
			self.aimAngle = math.min(self.targetAngle, self.aimAngle + 0.06)
		elseif self.targetAngle < self.aimAngle then
			self.aimAngle = math.max(self.targetAngle, self.aimAngle - 0.06)
		end
		
		if self.targetAngle > self.Barrel.RotAngle - 0.005 and self.targetAngle < self.Barrel.RotAngle + 0.005 then
			if MovableMan:IsActor(self.SearchPtr) then
				self.timing = RangeRand(4900, 5100)	-- Reload
				self.SearchTimer:Reset()
				
				-- Flash
				local Flash = CreateAEmitter("Launch Flash", "Air Support.rte")
				Flash.RotAngle = self.Barrel.RotAngle
				
				-- SAM
				local Missile = CreateAEmitter("SAM", "Air Support.rte")
				Missile.RotAngle = self.Barrel.RotAngle
				Missile.Vel = self.Barrel:RotateOffset(Vector(5,0))
				Missile.Sharpness = self.SearchPtr.ID	-- Transfer target ID
				
				if self.round % 2 == 0 then
					Flash.Pos = self.Barrel.Pos + self.Barrel:RotateOffset(Vector(22,-3))
					Missile.Pos = self.Barrel.Pos + self.Barrel:RotateOffset(Vector(32,-3))
				else
					Flash.Pos = self.Barrel.Pos + self.Barrel:RotateOffset(Vector(22,3))
					Missile.Pos = self.Barrel.Pos + self.Barrel:RotateOffset(Vector(32,3))
				end
				
				MovableMan:AddParticle(Flash)
				MovableMan:AddParticle(Missile)
				
				self.round = self.round + 1
				self.targetAngle = nil
			else
				self.targetAngle = nil
			end
		elseif self.SearchTimer:IsPastSimMS(500) then
			self.targetAngle = math.min(math.max(1.571, self.RotAngle + 0.785), self.RotAngle + 2.356)
		end
	elseif self.SearchTimer:IsPastSimMS(self.timing) then	-- note that the timer is not reset untill a missile is launched
		if not self.SearchPtr then
			for Act in MovableMan.Actors do
				if Act.Team ~= self.Team then
					self.searchTeam = Act.Team
					self.SearchPtr = Act
					self.SearchName = Act.PresetName
					break
				end
			end
		elseif MovableMan:IsActor(self.SearchPtr) and self.SearchPtr.PresetName == self.SearchName then
			if self.next then
				self.SearchPtr = MovableMan:GetNextTeamActor(self.searchTeam, self.SearchPtr)
			else
				self.SearchPtr = MovableMan:GetPrevTeamActor(self.searchTeam, self.SearchPtr)
			end
			
			if self.SearchPtr then
				self.SearchName = self.SearchPtr.PresetName
			end
		else
			self.SearchPtr = nil
		end
		
		if self.SearchPtr and MovableMan:IsActor(self.SearchPtr) and self.SearchPtr.Status ~= Actor.DYING and
			 (self.SearchPtr.ClassName == "ACRocket" or self.SearchPtr.ClassName == "ACDropShip")
		then
			local Range = SceneMan:ShortestDistance(self.Pos, self.SearchPtr.Pos, false)
			if self.SearchPtr.Pos.Y < self.Pos.Y - 75 or (self.SearchPtr.Pos.Y < self.Pos.Y - 25 and math.abs(Range.X) > 550) then
				-- Predict target pos to avoid shooting at targets impossible to hit
				local t2t = math.min((Range.Magnitude / 25) * 0.75, 25)	-- Estimated time to target
				local AimPoint = self.SearchPtr.Pos + self.SearchPtr.Vel * t2t	-- Estimated point of collision
				
				if AimPoint.Y < SceneMan.SceneHeight and AimPoint.Y > 0 and (SceneMan.SceneWrapsX or 
					(AimPoint.X < SceneMan.SceneWidth and AimPoint.X > 0))
				then
					-- Make sure AimPoint is not inside terrain
					Range = SceneMan:ShortestDistance(self.Pos, AimPoint, false)	-- Distance vector to the estimated point of collision
					local Tmp = Vector(0,0)
					if SceneMan:CastObstacleRay(self.Pos, Range, Vector(), Tmp, self.SearchPtr.ID, -1, 9) < 0 then
						Range = SceneMan:ShortestDistance(self.Pos, Tmp, false)
						AimPoint:SetXY(Tmp.X, Tmp.Y)
					end
					
					local dist = Range.Magnitude
					if dist > 80 and dist < 2000 then	-- Target in range
						self.SearchTimer:Reset()
						if SceneMan:CastObstacleRay(self.AboveHUDPos, Range, Tmp, Tmp, self.SearchPtr.ID, -1, 4) < 0 then	-- LOS to target
							self.targetAngle = Range.AbsRadAngle
						else
							if Range.AbsRadAngle > 1.771 then
								self.targetAngle = 1.871
								local Trace = Vector(200, 0):RadRotate(self.targetAngle)
								if SceneMan:CastObstacleRay(self.AboveHUDPos, Trace, Tmp, Tmp, self.SearchPtr.ID, -1, 4) > -1 then
									self.targetAngle = 1.571
								end
							elseif Range.AbsRadAngle < 1.371 then
								self.targetAngle = 1.271
								local Trace = Vector(200, 0):RadRotate(self.targetAngle)
								if SceneMan:CastObstacleRay(self.AboveHUDPos, Trace, Tmp, Tmp, self.SearchPtr.ID, -1, 4) > -1 then
									self.targetAngle = 1.571
								end
							else
								self.targetAngle = 1.571
							end
						end
						
						self.targetAngle = math.min(math.max(self.targetAngle, self.RotAngle + 0.785), self.RotAngle + 2.356)
					end
				end
			end
		end
	end
end