function Create(self)
	self.AIMode = Actor.AIMODE_STAY
	self.Frame = 1
	self.Pos.Y = 30
	self.KeyTimer = Timer()
	self.Ctrl = self:GetController()
	self.index = UAV.Prefered or 1
	self.Variants = {"A", "B", "C", "D", "E", "F", "G", "J"}
	if self.Pos.X > SceneMan.SceneWidth/2 then
		self.HFlipped = true
	end
	
	-- Remove any inventory
	if not self:IsInventoryEmpty() then
		local Act = CreateACRocket(self.PresetName, "Air Support.rte")	-- Create an empty craft
		if Act then
			Act.Pos = self.Pos
			Act.Team = self.Team
			MovableMan:AddActor(Act)
		end
		
		self.Pos.Y = -50
		self.Vel.Y = -100	-- Remove without causing a loss
		self.Health = -100	-- Reduce gold value to zero
	end
end

function Destroy(self)
	if self.Glow and self.Glow.ClassName ~= "Entity" then
		self.Glow.ToDelete = true
	end
	
	if self.Icon and self.Icon.ClassName ~= "Entity" then
		self.Icon.ToDelete = true
	end
end

function Update(self)
	if not self:IsInventoryEmpty() then	-- Send back any craft with an inventory
		self.Vel.Y = -100
		return
	else
		if not self.Glow or self.Glow.ClassName == "Entity" then
			local name = "UAV Glow"
			if self.HFlipped then
				name = name .. " Left"
			end
			
			self.Glow = CreateMOPixel(name, "Air Support.rte")
			if self.Glow then
				self.Glow.Pos = self.Pos
				MovableMan:AddParticle(self.Glow)
			end
		else
			self.Glow.Age = 1
		end
		
		if not self.Icon or self.Icon.ClassName == "Entity" then
			self.Icon = CreateMOPixel("WeaponGlow" .. self.index, "Air Support.rte")
			if self.Icon then
				self.Icon.Pos = self.Pos + Vector(0, 32)
				MovableMan:AddParticle(self.Icon)
			end
		else
			self.Icon.Age = 1
		end
	end
	
	if self.AIMode == Actor.AIMODE_RETURN then
		self.Vel.Y = -100
	else
		self.Vel.X = 0
		self.Vel.Y = 0
	end
	
	if self:IsPlayerControlled() then
		self.Frame = 2
		if self.Ctrl:IsState(Controller.PRESS_LEFT) and not self.HFlipped then
			if self.Glow and self.Glow.ClassName ~= "Entity" then
				self.Glow.ToDelete = true
			end
			
			self.Glow = nil
			self.HFlipped = true
		elseif self.Ctrl:IsState(Controller.PRESS_RIGHT) and self.HFlipped then
			if self.Glow and self.Glow.ClassName ~= "Entity" then
				self.Glow.ToDelete = true
			end
			
			self.Glow = nil
			self.HFlipped = false
		elseif self.Ctrl:IsState(Controller.PRESS_UP) or self.Ctrl:IsState(Controller.WEAPON_CHANGE_PREV) then
			if self.index < 2 then
				self.index = #self.Variants
			else
				self.index = self.index - 1
			end
			
			if self.Icon and self.Icon.ClassName ~= "Entity" then
				self.Icon.ToDelete = true
			end
			
			self.Icon = nil
		elseif self.Ctrl:IsState(Controller.PRESS_DOWN) or self.Ctrl:IsState(Controller.WEAPON_CHANGE_NEXT) then
			if self.index >= #self.Variants then
				self.index = 1
			else
				self.index = self.index + 1
			end
			
			if self.Icon and self.Icon.ClassName ~= "Entity" then
				self.Icon.ToDelete = true
			end
			
			self.Icon = nil
		elseif self.Ctrl:IsState(Controller.RELEASE_PRIMARY) and self.KeyTimer:IsPastSimMS(500) then
			self.AIMode = Actor.AIMODE_RETURN
			self.Vel.Y = -100	-- Remove without causing a loss
			self.Health = -100	-- Reduce gold value to zero
			UAV.Prefered = self.index
			
			local name = "UAV-" .. self.Variants[self.index]
			if self.HFlipped then
				name = name .. " Left"
			end
			
			local UAV = CreateACRocket(name, "Air Support.rte")
			if UAV then
				UAV.Pos = self.Pos + Vector(0,-5)
				UAV.Team = self.Team
				MovableMan:AddActor(UAV)
				--ActivityMan:GetActivity():SwitchToActor(UAV, UAV.Team, UAV.Team)
				ActivityMan:GetActivity():SwitchToActor(UAV, self.Ctrl.Player, UAV.Team)
			end
		end
	else
		self.Frame = 1
		self.KeyTimer:Reset()
	end
end