local tmp = package.path
package.path = package.path .. ";Air Support.rte/?.lua"
require("common")
package.path = tmp

function Create(self)
	UAV.Initialize(self)
	
	-- specific for this craft
	self.AimDistance = self.AimDistance * 1.1
	self.payload = 28
	self.payloadRof = 70	-- time in ms between launches
end

function Destroy(self)
	UAV.Destroy(self)
end

function Update(self)
	UAV.Move(self)
	
	if self:IsPlayerControlled() then
		UAV.PlayerControlled(self)
		UAV.Map(self)
		
		-- MGs
		if self.Ctrl:IsState(Controller.PRIMARY_ACTION) then
			if self.ammo > 0 then
				UAV.FireMG(self)
			else
				UAV.AddIcon(self, CreateMOSParticle("No Ammo"), 5)
			end
		end
		
		-- specific for this craft
		if self.DropTimer:IsPastSimMS(self.payloadRof) and self.Ctrl:IsState(self.secondary) then
			if self.payload > 0 then	-- Fire Rocket
				self.DropTimer:Reset()
				
				local Rocket = CreateAEmitter("FFAR")
				Rocket.Vel = UAV.Offset(self.Vel, self.angle, 27)
				Rocket.Pos = self.Pos + self:RotateOffset(Vector(math.abs(Rocket.SpriteOffset.X) + self.speed, math.abs(Rocket.SpriteOffset.Y) + 14))
				Rocket.RotAngle = self.angle
				MovableMan:AddParticle(Rocket)
				
				local Blast  = CreateAEmitter("Back Blast")
				Blast.Vel = self.Vel
				Blast.Pos = self.Pos + self:RotateOffset(Vector(-10, 14))
				Blast.RotAngle = self.angle
				MovableMan:AddParticle(Blast)
				
				self.payload = self.payload - 1
				if self.payload % 9 == 0 then
					self:AddInventoryItem(CreateHDFirearm(".", "Air Support.rte"))	-- Negative Gold
				end
			else
				UAV.AddIcon(self, CreateMOSParticle("No Ammo"), 5)
			end
		end
	elseif self.playerCtrl then
		UAV.Destroy(self)
	end
end