local tmp = package.path
package.path = package.path .. ";Air Support.rte/?.lua"
require("common")
package.path = tmp

function Create(self)
	UAV.Initialize(self)
	
	-- specific for this craft
	self.AimDistance = self.AimDistance * 1.1
	self.payload = 200
	self.payloadRof = 100	-- time in ms between rounds (100 = 2x600rpm)
end

function Destroy(self)
	UAV.Destroy(self)
end

function Update(self)
	UAV.Move(self)
	
	if self:IsPlayerControlled() then
		UAV.PlayerControlled(self)
		UAV.Map(self)
		
		-- specific for this craft
		if self.Ctrl:IsState(Controller.PRIMARY_ACTION) then
			if self.ammo > 0 then
				UAV.FireMG(self)
			end
			
			if self.payload > 0 and self.DropTimer:IsPastSimMS(self.payloadRof) then	-- Fire gun pods
				self.DropTimer:Reset()
				
				if self.payload % 2 == 0 then
					local Emitter = CreateAEmitter("UAV 50 cal Tracer", "Air Support.rte")
					Emitter.Vel = self.Vel
					Emitter.Pos = self.Pos + self:RotateOffset(Vector(math.abs(self.SpriteOffset.X) + 15, 16))
					Emitter.RotAngle = self.angle + RangeRand(-0.022, 0.022)
					MovableMan:AddParticle(Emitter)
					
					Emitter = CreateAEmitter("UAV 50 cal", "Air Support.rte")
					Emitter.Vel = self.Vel
					Emitter.Pos = self.Pos + self:RotateOffset(Vector(math.abs(self.SpriteOffset.X) + 15, 16))
					Emitter.RotAngle = self.angle + RangeRand(-0.032, 0.032)
					MovableMan:AddParticle(Emitter)
				else
					local Emitter = CreateAEmitter("UAV 50 cal", "Air Support.rte")
					Emitter.Vel = self.Vel
					Emitter.Pos = self.Pos + self:RotateOffset(Vector(math.abs(self.SpriteOffset.X) + 15, 16))
					Emitter.RotAngle = self.angle + RangeRand(-0.032, 0.032)
					MovableMan:AddParticle(Emitter)
					
					Emitter = CreateAEmitter("UAV 50 cal", "Air Support.rte")
					Emitter.Vel = self.Vel
					Emitter.Pos = self.Pos + self:RotateOffset(Vector(math.abs(self.SpriteOffset.X) + 15, 16))
					Emitter.RotAngle = self.angle + RangeRand(-0.032, 0.032)
					MovableMan:AddParticle(Emitter)
				end
				
				self.payload = self.payload - 1
				if self.payload % 44 == 0 then
					self:AddInventoryItem(CreateHDFirearm(".", "Air Support.rte"))	-- Negative Gold
				end
			end
			
			if self.ammo < 1 and self.payload < 1 then
				UAV.AddIcon(self, CreateMOSParticle("No Ammo"), 5)
			end
		end
	elseif self.playerCtrl then
		UAV.Destroy(self)
	end
end