local tmp = package.path
package.path = package.path .. ";Air Support.rte/?.lua"
require("common")
package.path = tmp

function Create(self)
	UAV.Initialize(self)
	
	-- specific for this craft
	self.Frame = 1
	
	self.Missile = CreateMOSRotating("Ball Bomb Dummy", "Air Support.rte")
	if self.Missile then
		self.Missile.Vel = self.Vel
		self.Missile.Pos = self.Pos + self:RotateOffset(Vector(8, math.abs(self.Missile.SpriteOffset.Y) + 10))
		self.Missile.RotAngle = self.RotAngle
		MovableMan:AddParticle(self.Missile)
	end
end

function Destroy(self)
	UAV.Destroy(self)
	
	if self.Missile and MovableMan:ValidMO(self.Missile) and self.Missile.ClassName ~= "Entity" then
		self.Missile.ToDelete = true
	end
end

function Update(self)	
	UAV.Move(self)
	
	-- Move the ball bomb
	if self.Missile and MovableMan:ValidMO(self.Missile) and self.Missile.ClassName ~= "Entity" then
		self.Missile.Vel = self.Vel
		self.Missile.Pos = self.Pos + self:RotateOffset(Vector(5, math.abs(self.Missile.SpriteOffset.Y) + 1))
		
		if self.HFlipped then
			self.Missile.RotAngle = self.angle + 1.571
		else
			self.Missile.RotAngle = self.angle
		end
	end
	
	if self:IsPlayerControlled() then
		UAV.PlayerControlled(self)
		UAV.Map(self)
		
		-- MGs
		if self.Ctrl:IsState(Controller.PRIMARY_ACTION) then
			if self.ammo > 0 then
				UAV.FireMG(self)
			else
				UAV.AddIcon(self, CreateMOSParticle("No Ammo", "Air Support.rte"), 5)
			end
		end
		
		-- specific for this craft
		if self.Ctrl:IsState(self.secondary) then
			if self.Missile and MovableMan:ValidMO(self.Missile) and self.Missile.ClassName ~= "Entity" then
				self.Missile.ToDelete = true
				self.Missile = nil
				
				if self.HFlipped then
					self.bomb = "Ball Bomb Left"
				else
					self.bomb = "Ball Bomb Right"
				end
				
				local Bomb = CreateADoor(self.bomb, "Air Support.rte")
				Bomb.Pos = self.Pos + self:RotateOffset(Vector(5, math.abs(self.SpriteOffset.Y) + math.abs(Bomb.SpriteOffset.Y) - 7))
				Bomb.RotAngle = self.angle
				Bomb.Team = self.Team
				Bomb.Vel = self.Vel + self:RotateOffset(Vector(0, 2))
				MovableMan:AddActor(Bomb)
				
				self:AddInventoryItem(CreateHDFirearm(".", "Air Support.rte"))	-- Negative Gold
				self:AddInventoryItem(CreateHDFirearm(".", "Air Support.rte"))	-- Negative Gold
				self:AddInventoryItem(CreateHDFirearm(".", "Air Support.rte"))	-- Negative Gold
				self:AddInventoryItem(CreateHDFirearm(".", "Air Support.rte"))	-- Negative Gold
			else
				UAV.AddIcon(self, CreateMOSParticle("No Ammo"), 5)
			end
		end
	elseif self.playerCtrl then
		UAV.Destroy(self)
	end
end