local tmp = package.path
package.path = package.path .. ";Air Support.rte/?.lua"
require("common")
package.path = tmp

function Create(self)
	UAV.Initialize(self)
	
	-- specific for this craft
	self.AimDistance = self.AimDistance * 1.1
	self.payload = 1
	self.Missile = CreateADoor("Jericho Missile", "Air Support.rte")
	if self.Missile then
		self.Missile.Vel = self.Vel
		self.Missile.Pos = self.Pos + self:RotateOffset(Vector(8, math.abs(self.Missile.SpriteOffset.Y) + 10))
		self.Missile.Team = self.Team
		self.Missile.RotAngle = self.RotAngle
		MovableMan:AddActor(self.Missile)
	end
end

function Destroy(self)
	UAV.Destroy(self)
	
	if self.Missile and MovableMan:ValidMO(self.Missile) and self.Missile.Pos.Y < 0 then
		self.Missile.ToDelete = true
	end
end

function Update(self)
	-- Move the Jericho
	if self.Missile and MovableMan:ValidMO(self.Missile) and self.Missile.ClassName ~= "Entity" then
		self.Missile.Vel = self.Vel
		self.Missile.Pos = self.Pos + self:RotateOffset(Vector(8, math.abs(self.Missile.SpriteOffset.Y) + 10))
		self.Missile.RotAngle = self.angle
	end
	
	UAV.Move(self)
	
	if self:IsPlayerControlled() then
		UAV.PlayerControlled(self)
		UAV.Map(self)
		
		-- MGs
		if self.Ctrl:IsState(Controller.PRIMARY_ACTION) then
			if self.ammo > 0 then
				UAV.FireMG(self)
			else
				UAV.AddIcon(self, CreateMOSParticle("No Ammo", "Air Support.rte"), 5)
			end
		end
		
		-- specific for this craft
		if self.Ctrl:IsState(self.secondary) then
			if self.Missile and MovableMan:ValidMO(self.Missile) and self.Missile.ClassName ~= "Entity" then
				self.Missile.Sharpness = 1	-- Activate proximity fuse
				self.Missile.Team = self.Team
				self.Missile:SetWhichMOToNotHit(self, 0.1)
				self.Missile = nil
				self.Mass = 450
				
				for i = 1, 8 do
					self:AddInventoryItem(CreateHDFirearm(".", "Air Support.rte"))	-- Negative Gold
				end
			else
				UAV.AddIcon(self, CreateMOSParticle("No Ammo"), 5)
			end
		end
	elseif self.playerCtrl then
		UAV.Destroy(self)
	end
end