function Create(self)
	self.timing = 300
	self.angle = 0
end

function Destroy(self)
	ActivityMan:GetActivity():ReportDeath(self.Team, -1)
	if self.index and UAV.Ordnance then
		UAV.Ordnance[self.index] = nil
	end
end

function Update(self)
	if self.Sharpness > 0 then	-- The rocket is inert while Sharpness is zero
		if not self.RocketTimer then
			self.RocketTimer = Timer()
			self.RayTimer = Timer()
			
			if not UAV.Ordnance then
				UAV.Ordnance = {}
			end
			
			self.index = #UAV.Ordnance + 1
			UAV.Ordnance[self.index] = self
			
			local Blast = CreateAEmitter("Jericho Back Blast", "Air Support.rte")
			Blast.Pos = self.Pos + self:RotateOffset(Vector(-32, 0))
			Blast.Vel = self.Vel
			Blast.RotAngle = self.RotAngle
			MovableMan:AddParticle(Blast)
		else
			local NewPos = self.Pos + self:RotateOffset(Vector(-32, 0))
			if self.RocketTimer:IsPastSimMS(800) then	-- Smoke
				local Trail = CreateMOSParticle("Tiny Smoke Ball Fast", "Air Support.rte")
				Trail.Pos = NewPos + NewPos.Perpendicular:Normalize()*RangeRand(-4, 4)
				Trail.Vel = self.Vel
				MovableMan:AddParticle(Trail)
			else
				local Trail = CreateMOSParticle("Main Thruster Blast Ball 1", "Air Support.rte")
				Trail.Pos = NewPos + NewPos.Perpendicular:Normalize()*RangeRand(-4, 4)
				Trail.Vel = self.Vel
				MovableMan:AddParticle(Trail)
				
				self.Vel = UAV.Offset(self.Vel, self.RotAngle, 0.7)	-- Accelerate
			end
			
			if self.RayTimer:IsPastSimMS(self.timing) then
				self.RayTimer:Reset()
				self.timing = 50
				
				local obstRng = SceneMan:CastObstacleRay(self.Pos, UAV.Offset(self.Pos, self.RotAngle + self.angle, 1500), Vector(), Vector(), self.ID, 0, 2)
				if obstRng > -1 and (self.RotAngle < 0.1416 or self.RotAngle > 3 or obstRng < 350) and obstRng < (800 + self.Vel.Magnitude * 10) then	-- Obstacle found, Mirv if facing the ground
					self.HitsMOs = false
					self.GetsHitByMOs = false
					
					local Rocket = CreateMOSRotating("Spent Jericho Missile", "Air Support.rte")
					Rocket.Pos = self.Pos
					Rocket.Vel = self.Vel
					Rocket.Team = self.Team
					Rocket.RotAngle = self.RotAngle
					Rocket.AngularVel = self.AngularVel
					MovableMan:AddParticle(Rocket)
					
					local RightSide = self.Pos - self.Pos.Perpendicular.Normalized * 5
					local LeftSide = self.Pos + self.Pos.Perpendicular.Normalized * 5
					local Panel = nil
					for i = 1, 8 do
						Panel = CreateMOSRotating("Jericho Panel", "Air Support.rte")
						if i % 2 == 0 then
							Panel.Pos = RightSide
							Panel.RotAngle = self.RotAngle + RangeRand(-0.4, 0.0)
						else
							Panel.Pos = LeftSide
							Panel.RotAngle = self.RotAngle + RangeRand(0.0, 0.4)
						end
						
						Panel.AngularVel = RangeRand(-8, 8)
						Panel.Vel = UAV.Offset(nil, Panel.RotAngle, self.Vel.Magnitude * RangeRand(0.6, 1.0))
						MovableMan:AddParticle(Panel)
						Panel:SetWhichMOToNotHit(Rocket, -1)
					end
					
					self.ToDelete = true	-- remove without spawning gibs
				else	-- cast rays in a narrow cone
					if self.angle > 0.01 then
						self.angle = -0.1
					elseif self.angle < -0.01 then
						self.angle = 0
					else
						self.angle = 0.1
					end
				end
			end
		end
	end
end 