function Create(self)
	self.SwarmTimer = Timer()
	self.swarmMissiles = 30
	
	if not UAV.Ordnance then
		UAV.Ordnance = {}
	end
	
	self.index = #UAV.Ordnance + 1
	UAV.Ordnance[self.index] = self
end

function Destroy(self)
	if UAV.Ordnance then
		UAV.Ordnance[self.index] = nil
	end
end

function Update(self)
	if self.swarmMissiles > 0 and self.SwarmTimer:IsPastSimMS(50) then
		self.SwarmTimer:Reset()
		
		local alt = self:GetAltitude(800, 5)
		if self.RotAngle < -0.4 or self.RotAngle > 3.541592 or alt < 300 then
			-- Spawn them in small groups to reduce lag
			local Volley = 6
			local Missile = nil
			local RightSide = self.Pos - self.Pos.Perpendicular.Normalized * 5
			local LeftSide = self.Pos + self.Pos.Perpendicular.Normalized * 5
			local spread = math.abs((Vector(self.Pos.X + 250, self.Pos.Y + alt) - self.Pos).AbsRadAngle)
			local part = spread / (Volley/2)	-- spread within a cone with a base of 500 pixels
			
			for i = 1, Volley do
				Missile = CreateAEmitter("Jericho Swarm Missile", "Air Support.rte")
				if Missile then
					if i % 2 == 0 then
						Missile.Pos = RightSide
					else
						Missile.Pos = LeftSide
					end
					
					Missile.RotAngle = self.RotAngle + spread
					Missile.Vel = UAV.Offset(self.Vel/4, Missile.RotAngle, self.Vel.Magnitude/2)	-- inherit parts of the Jerochos velocity
					Missile:SetWhichMOToNotHit(self, -1)
					self:SetWhichMOToNotHit(Missile, -1)
					MovableMan:AddParticle(Missile)
				end
				
				spread = spread - part
				self.swarmMissiles = self.swarmMissiles - 1
			end
		end
	end
end 