
function RunningMan:StartActivity()
	collectgarbage("collect")
	
	self.RonSide = {"Desert Eagle", "Glock", "Peacemaker", "Shortgun"}
	self.RonWeps = {"RPG-7", "AK-47", "M60", "Uzi", "M16", "Spas 12", "Pumpgun", "M1 Garand", "Kar98", "Thumper", "RPC M17"}
	self.CoaSide = {"Pistol.", "Auto Pistol.", "Carbine."}
	self.CoaWeps = {"Sniper Rifle.", "Heavy Sniper Rifle.", "Assault Rifle.", "Napalm Flamer.",
									"Flak Cannon.",	"Shotgun.", "Auto Shotgun.", "Auto Cannon.", "Revolver Cannon.",
									"Rocket Launcher.", "Homing Missile Launcher."}
	self.WList = {}
	self.SList = {}
	for k,Val in pairs(self.CoaSide) do table.insert(self.SList, "Air Support/"..Val) end
	for k,Val in pairs(self.CoaWeps) do table.insert(self.WList, "Air Support/"..Val) end
	
	-- Check if we already have a brain assigned
	if not self:GetPlayerBrain(Activity.PLAYER_1) then
		local foundBrain = MovableMan:GetUnassignedBrain(self:GetTeamOfPlayer(Activity.PLAYER_1))
		-- If we can't find an unassigned brain in the scene to give the player, then force to go into editing mode to place one
		if not foundBrain then
			foundBrain = CreateAHuman("Air Support/RClone")			
			foundBrain:AddInventoryItem(CreateHDFirearm("Ronin/" .. self.RonWeps[math.random(1,#self.RonWeps)]))
			foundBrain:AddInventoryItem(CreateHDFirearm("Ronin/" .. self.RonSide[math.random(1,#self.RonSide)]))
			foundBrain:AddInventoryItem(CreateTDExplosive("Ronin/Stick Grenade"))
			foundBrain.Pos = SceneMan:MovePointToGround(Vector(math.random(0, SceneMan.SceneWidth), 0), 0, 0) + Vector(0, -50)
			foundBrain.Team = self:GetTeamOfPlayer(Activity.PLAYER_1)
			MovableMan:AddActor(foundBrain)
			-- Set the found brain to be the selected actor at start
			self:SetPlayerBrain(foundBrain, Activity.PLAYER_1)
			self:SwitchToActor(foundBrain, Activity.PLAYER_1, self:GetTeamOfPlayer(Activity.PLAYER_1))
			self:SetLandingZone(self:GetPlayerBrain(Activity.PLAYER_1).Pos, Activity.PLAYER_1)
			-- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
			self:SetObservationTarget(self:GetPlayerBrain(Activity.PLAYER_1).Pos, Activity.PLAYER_1)
		else
			-- Set the found brain to be the selected actor at start
			self:SetPlayerBrain(foundBrain, Activity.PLAYER_1)
			self:SwitchToActor(foundBrain, Activity.PLAYER_1, self:GetTeamOfPlayer(Activity.PLAYER_1))
			self:SetLandingZone(self:GetPlayerBrain(Activity.PLAYER_1).Pos, Activity.PLAYER_1)
			-- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
			self:SetObservationTarget(self:GetPlayerBrain(Activity.PLAYER_1).Pos, Activity.PLAYER_1)
		end
	end
	
	ActivityMan:GetActivity():SetTeamFunds(0,0)
	
	self.TimeLeft = 0
	self.StartTimer = Timer()
	self.SpawnTimer = Timer()
	self.SurvivalTimer = Timer()
	
	self.AList = {"Air Support/CClone", "Coalition/Soldier Light"}
	
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self.TimeLimit = 45*1000
		self.timeDisplay = "fortyfive seconds"
		self.BaseSpawnTime = 7000
		self.RandomSpawnTime = 10000
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self.TimeLimit = 60*1000
		self.timeDisplay = "one minute"
		self.BaseSpawnTime = 5500
		self.RandomSpawnTime = 9000
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self.TimeLimit = 2*60*1000
		self.timeDisplay = "two minutes"
		self.BaseSpawnTime = 5000
		self.RandomSpawnTime = 8000
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self.TimeLimit = 3*60*1000
		self.timeDisplay = "three minutes"
		self.BaseSpawnTime = 4500
		self.RandomSpawnTime = 6000
		table.insert(self.AList, "Air Support/CClone")
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self.TimeLimit = 4*60*1000
		self.timeDisplay = "four minutes"
		self.BaseSpawnTime = 4000
		self.RandomSpawnTime = 4500
		table.insert(self.AList, "Air Support/CClone")
	elseif self.Difficulty <= GameActivity.MAXDIFFICULTY then
		self.TimeLimit = 6*60*1000
		self.timeDisplay = "six minutes"
		self.BaseSpawnTime = 3500
		self.RandomSpawnTime = 4000
		table.insert(self.AList, "Air Support/CClone")
		table.insert(self.AList, "Air Support/CClone")
	end
	
	local Craft = self:SpawnAI()
	if Craft then
		local Target = self:GetPlayerBrain(0)
		Craft.Pos = SceneMan:MovePointToGround(Vector(Craft.Pos.X, 0), 0, 0) + Vector(0, -200)
		Craft.Pos.Y = math.max(Craft.Pos.Y, -50)
		Craft.Vel.Y = 1
	end
end

function RunningMan:UpdateActivity()
	if self.ActivityState ~= Activity.OVER then
		ActivityMan:GetActivity():SetTeamFunds(0,0)
		for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
			if self:PlayerActive(player) and self:PlayerHuman(player) then
				--Display messages
				if self.StartTimer:IsPastSimMS(3000) then
					FrameMan:SetScreenText(math.floor(self.SurvivalTimer:LeftTillSimMS(self.TimeLimit) / 1000) .. " seconds left", player, 0, 1000, false)
				else
					FrameMan:SetScreenText("Survive for " .. self.timeDisplay .. "!", Activity.PLAYER_1, 333, 5000, true)
				end
			
				-- The current player's team
				local team = self:GetTeamOfPlayer(player)
				-- Check if any player's brain is dead
				if not MovableMan:IsActor(self:GetPlayerBrain(player)) then
					self:SetPlayerBrain(nil, player)
					self:ResetMessageTimer(player)
					FrameMan:ClearScreenText(player)
					FrameMan:SetScreenText("Your brain has been destroyed!", player, 333, -1, false)
					-- Now see if all brains of self player's team are dead, and if so, end the game
					if not MovableMan:GetClosestBrainActor(team, Vector(0,0)) then
						self.WinnerTeam = self:OtherTeam(team)
						ActivityMan:EndActivity()
					end
				end
				
				--Check if the player has won
				if self.SurvivalTimer:IsPastSimMS(self.TimeLimit) then
					self:ResetMessageTimer(player)
					FrameMan:ClearScreenText(player)
					FrameMan:SetScreenText("A winner is you!", player, 333, -1, false)
					
					self.WinnerTeam = Activity.TEAM_1
					
					--Kill all enemies
					for actor in MovableMan.Actors do
						if actor.Team ~= self.WinnerTeam then
							actor.Health = 0
						end
					end

					ActivityMan:EndActivity()
				end
			end
		end

		-- Spawn the AI
		if self.SpawnTimer:LeftTillSimMS(self.TimeLeft) <= 0 and MovableMan:GetMOIDCount() <= 210 then
			self.SpawnTimer:Reset()
			self.TimeLeft = self.BaseSpawnTime + math.random(self.RandomSpawnTime)
			self:SpawnAI()
		end
	end
end

function RunningMan:SpawnAI()
	local Actors = {}
	local Target = self:GetPlayerBrain(0)
	local Craft, maxCargo
	
	if not MovableMan:IsActor(Target) then
		Target = nil
	end
	
	local z = math.random()
	if z > 0.6 then
		maxCargo = math.random(2,4)
		Craft = CreateACDropShip("Drop Ship MK1a","Air Support.rte")
		Craft.Vel.Y = 10
	elseif z > 0.2 then
		maxCargo = math.random(1,2)
		Craft = CreateACRocket("Rocket MK3","Air Support.rte")
		Craft.Vel.Y = 5
	else
		maxCargo = math.random(1,2)
		Craft = CreateACRocket("Rocket MK1a","Air Support.rte")
	end
	
	for i = 1, maxCargo do
		Actors[i] = CreateAHuman(self.AList[math.random(#self.AList)])
		Actors[i].Team = Activity.TEAM_2
		
		local Wep = CreateHDFirearm(self.WList[math.random(1,#self.WList)])
		if Wep then
			Actors[i]:AddInventoryItem(Wep)
		end
		
		if PosRand() < 0.8 then
			Wep = CreateHDFirearm(self.SList[math.random(1,#self.SList)])
			if Wep then
				Actors[i]:AddInventoryItem(Wep)
			end
		end
		
		local y = PosRand()
		if y < 0.2 and Target then
			Actors[i].AIMode = Actor.AIMODE_GOTO
			Actors[i]:AddAIMOWaypoint(Target)
		elseif y < 0.8 and Target then
			Actors[i].AIMode = Actor.AIMODE_GOTO
			Actors[i]:AddAISceneWaypoint(Target.Pos)
		else
			Actors[i].AIMode = Actor.AIMODE_BRAINHUNT
		end
	end
	
	for _,Act in pairs(Actors) do
		Craft:AddInventoryItem(Act)
	end
	
	Craft.Team = Activity.TEAM_2
	if PosRand() > 0.5 then
		Craft.Pos = Vector(Target.Pos.X + RangeRand(300,900), -50)
	else
		Craft.Pos = Vector(Target.Pos.X - RangeRand(300,900), -50)
	end
	
	MovableMan:AddActor(Craft)
	return Craft
end