function Tutorial:StartActivity()
	self.TargetTimer = Timer()
	self.MsgTimer = Timer()
	self.Strings = {"Triple tap left or right to change direction",
					"Select 'Undercarriage' in the pie-menu \nto extend and retract the landing gears",
					"Jump/crouch to aim MG",
					"Press sharp aim to fire rockets"}
	self.msg = 1
	
	for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
		if self:PlayerActive(player) and self:PlayerHuman(player) then
			-- Player brain
			local Brain = CreateActor("Brain Case", "Base.rte")
			Brain.Pos = Vector(480 + player * 16, 1028)
			MovableMan:AddActor(Brain)
			self:SetPlayerBrain(Brain, player)
			self:SetObservationTarget(Brain.Pos, player)
			
			-- Gunship
			self.Gunship = CreateACDropShip("Hydra Gunship", "Air Support.rte")
			if self.Gunship then
				self.Gunship.Pos = SceneMan:MovePointToGround(Vector(250 + player * 200, 120 - player * 30), 150, 5)
				self.Gunship.Vel = Vector(0, 0)
				self.Gunship.Team = Activity.TEAM_1
				self.Gunship.Health = 47
				MovableMan:AddActor(self.Gunship)
				self:SwitchToActor(self.Gunship, player, self.Gunship.Team)
				print(self.Gunship.PresetName .. " reload = " .. self.Gunship:ReloadScripts())
				
				if self.Gunship:GetController():IsMouseControlled() then
					self.Strings = {"Double tap left to change direction",
									"Select 'Undercarriage' in the pie-menu \nto extend and retract the landing gears",
									"Mouse to aim MG",
									"Press X to fire rockets"}
				end
			end
		end
	end
	
	-- Only allow the scene for Verdun
	SceneMan.Scene:GetArea("SpawnArea")
end

function Tutorial:UpdateActivity()
	self:ClearObjectivePoints()
	
	if not self.Pad then
		for Act in MovableMan.Actors do
			if Act.PresetName == "Repair System" then
				self.Pad = Act
				break
			end
		end
	elseif MovableMan:IsActor(self.Pad) then
		self:AddObjectivePoint("Land here to rearm and repair", self.Pad.Pos + Vector(0,-10), Activity.TEAM_1, GameActivity.ARROWDOWN)
	end
	
	if not MovableMan:IsActor(self.Gunship) or self.Gunship.PresetName == "Entity" then
		self.Gunship = CreateACDropShip("Hydra Gunship", "Air Support.rte")
		if self.Gunship then
			self.Gunship.Pos = Vector(200, -50)
			self.Gunship.Vel = Vector(0, 15)
			self.Gunship.Team = Activity.TEAM_1
			MovableMan:AddActor(self.Gunship)
			--self:SwitchToActor(ToActor(self.Gunship), 0, self.Gunship.Team)
		end
	else
		self:AddObjectivePoint(self.Strings[self.msg], self.Gunship.AboveHUDPos + Vector(0,-20), Activity.TEAM_1, GameActivity.ARROWDOWN)
		
		if SceneMan:ShortestDistance(self.Gunship.Pos, Vector(850,800), false).Magnitude < 75 then
			ActivityMan:StartActivity("GAScripted", "Verdun")
		end
	end
	
	self:AddObjectivePoint("Move here to start the mission", Vector(850,800), Activity.TEAM_1, GameActivity.ARROWDOWN)
	
	if self.MsgTimer:IsPastRealMS(4000) then
		self.MsgTimer:Reset()
		self.msg = self.msg + 1
		if self.msg > #self.Strings then
			self.msg = 1
		end
	end
	
	--[[
	if self.ScreenTimer then
		if self.ScreenTimer:IsPastSimMS(40) then
			self.ScreenTimer:Reset()
			FrameMan:SaveScreenToBMP("ScreenShots/Gunship")
		end
	else
		self.ScreenTimer = Timer()
	end]]
end